%define pkg_rel 5874d2a
%define rel 0-g%{pkg_rel}

Name:          jffi
Version:       1.0.10
Release:       %mkrel 0.0.%pkg_rel.2
Summary:       Java wrapper around libffi
Group:         Development/Java
URL:           http://github.com/wmeissner/jffi
# git clone git://github.com/wmeissner/jffi.git 
Source0:       https://download.github.com/wmeissner-jffi-1.0.10-0-g5874d2a.zip
Patch0:        jffi-1.0.9-GNUmakefile-flags.patch
Patch1:        jffi-1.0.2-custom-build_xml.patch
Patch2:        jffi-1.0.9-nblibraries_properties.patch
Patch3:        jffi-1.0.10-pom.patch
License:       GPL, LGPL, MIT
BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: ant-nodeps
BuildRequires: ecj
BuildRequires: java-devel
BuildRequires: junit
BuildRequires: junit4
BuildRequires: jpackage-utils
BuildRequires: glibc-devel
BuildRequires: libffi-devel
BuildRequires: make
Requires:      java
Requires:      jpackage-utils

%description
An optimized Java interface to libffi

%package javadoc
Group:          Development/Java
Summary:        Javadoc for %{name}

%description javadoc
An optimized Java interface to libffi.

This package contains javadoc for %{name}

%prep

%setup -q -n wmeissner-jffi-%{pkg_rel}

for j in $(find lib -name "*.jar"); do
  mv $j $j.no
done

for j in $(find lib -name "*.class"); do
  rm -f $j
done

rm -rf archive/ jni/win32/ lib/CopyLibs/

# use system libffi
rm -rf jni/libffi

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0

ln -sf $(build-classpath junit) lib/junit/
ln -sf $(build-classpath junit4) lib/junit_4/ 

chmod 644 jni/jffi/jffi.h

%build

export JAVA_HOME=%java_home
export CFLAG=$CFLAG:$(pkg-config --cflags-only-I libffi)
export CLASSPATH=$(build-classpath ecj)
ant \
  -Djava.home=%java_home \
  -Dmake.exe=%{_bindir}/make \
  jar javadoc

# x jruby
mkdir -p temp_jar/com/kenai/%{name}
cat > temp_jar/com/kenai/%{name}/boot.properties << _EOF
%{name}.boot.library.path = jni/%{_build_arch}-Linux
_EOF

pushd temp_jar
  jar -uf ../dist/%{name}-complete.jar com
popd

%install

mkdir -p %{buildroot}%{_jnidir}
mkdir -p %{buildroot}%{_libdir}/%{name}

install -pm 644 dist/%{name}-complete.jar \
  %{buildroot}%{_libdir}/%{name}/%{name}-%{version}.jar

(
  cd %{buildroot}%{_libdir}/%{name}
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`
  done
  ln -s ../%{name}/%{name}-%{version}.jar %{buildroot}%{_jnidir}/%{name}.jar
)

install -pm 755 build/jni/lib%{name}-1.0.so %{buildroot}%{_libdir}/%{name}/

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml  %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr dist/javadoc/* %{buildroot}%{_javadocdir}/%{name}

%check
ant test

%files
%{_jnidir}/%{name}.jar
%{_libdir}/%{name}/%{name}-%{version}.jar
%{_libdir}/%{name}/%{name}.jar
%{_libdir}/%{name}/lib%{name}-*.so
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%doc COPYING* LICENSE

%pre javadoc
[ $1 -gt 1 ] && [ -L %{_javadocdir}/%{name} ] && \
rm -rf $(readlink -f %{_javadocdir}/%{name}) %{_javadocdir}/%{name} || :

%files javadoc
%{_javadocdir}/%{name}


%changelog

* Sat Feb 25 2012 dmorgan <dmorgan> 1.0.10-0.0.5874d2a.2.mga2
+ Revision: 214246
- Rebuild for new pom
- Fix groups
- New version 1.0.10 snapshot
- Clean spec file

  + gil <gil>
    - update to 1.0.10
     add maven pom
    - cleanup
    - update to 1.0.9
    - update to 1.0.9
    - imported package jffi

